Public Member Functions | Data Fields

# SelectStationWindow< T > Struct Template Reference

Window for selecting stations/waypoints to (distant) join to. More...

Inheritance diagram for SelectStationWindow< T >:

## Public Member Functions
| SelectStationWindow (WindowDesc *desc, const CommandContainer &cmd, TileArea ta)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnTick ()
| Called once per (game) tick.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
## Data Fields
CommandContainer | select_station_cmd
| Command to build new station.
TileArea | area
| Location of new station.
Scrollbar * | vscroll

## Detailed Description

### template<class T>
struct SelectStationWindow< T >

Window for selecting stations/waypoints to (distant) join to.

Template Parameters:

  | T | The type of station to join with

Definition at line 2232 of file station_gui.cpp.

## Member Function Documentation

template<class T>

virtual void SelectStationWindow< T >::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 2269 of file station_gui.cpp.

References DrawString(), FACIL_WAYPOINT, Scrollbar::GetCapacity(), Scrollbar::GetPosition(), SmallVector< T, S >::Length(), Window::resize, SetDParam(), ResizeInfo::step_height, WD_FRAMERECT_LEFT, and WD_FRAMERECT_RIGHT.

template<class T>

virtual void SelectStationWindow< T >::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 2290 of file station_gui.cpp.

References DeleteWindowById(), DoCommandP(), Scrollbar::GetScrolledRowFromWidget(), SmallVector< T, S >::Length(), CommandContainer::p2, SB(), SelectStationWindow< T >::select_station_cmd, WC_SELECT_STATION, and WD_FRAMERECT_TOP.

template<class T>

virtual void SelectStationWindow< T >::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 2329 of file station_gui.cpp.

References SelectStationWindow< T >::area, SmallVector< T, S >::Length(), Scrollbar::SetCount(), and Window::SetDirty().

template<class T>

virtual void SelectStationWindow< T >::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 2319 of file station_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), WD_FRAMERECT_BOTTOM, and WD_FRAMERECT_TOP.

template<class T>

virtual void SelectStationWindow< T >::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 2249 of file station_gui.cpp.

References FACIL_WAYPOINT, GetStringBoundingBox(), SmallVector< T, S >::Length(), maxdim(), SetDParam(), WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

The documentation for this struct was generated from the following file:

- src/station_gui.cpp